# encoding: UTF-8
require_relative 'base'

module SSLTool
  class CertificateStore
    class FilesystemAdapter < Adapter
      def initialize(base_path)
        @base_path = base_path
      end

      def load_pool(pool_name)
        Certificate.scan(read_pool(pool_name)).to_set
      end

      def store_pool(pool_name, certs)
        return if read_pool(pool_name) == certs.to_set
        open(pool_path(pool_name), 'w') { |io| io.puts certs.map(&:to_pem).sort }
      end

      private

      def pool_path(pool_name)
        File.join(@base_path, "#{pool_name}.pem")
      end

      def read_pool(pool_name)
        path = pool_path(pool_name)
        return "" unless File.exists?(path)
        File.read(path).strip
      end
    end
  end
end
